function outImage = changeColorSpace(inImage, colorMatrix,HDR,NDf)
%function outImage = changeColorSpace(inImage, colorMatrix,HDR) % HDR is a HDR/LDR flag
% outImage = changeColorSpace('chart_filtered.tif', 'NDfilter2',0);
% written by: Lawrence Taplin and Garrett M. Johnson
% Based on scielab procedure of Wandell and Zhang
% The input image consists of three input images, say R,G,B, joined as 
%		inImage = [ R G B];
%
% The output image has the same format
% The 3 x 3 color matrix converts column vectors in the input image
% representation into column vectors in the output representation.
% Modified: 03/18/01
% Insured the input image is put back into the same format as it was passed.
% ---------- Added HDR flag for HDR use - jlj - 2007 ------------
% LDR are usually UINT8, HDR are usually DOUBLE
% SEE BOTTOM for command line possibilities
if HDR==0
	inImage0=ppmread(inImage);
	inImage0=double(inImage0);
end
%if HDR == 1;
%	inImage0 = radread(inImage);
%	a=(inImage0); %%%  see line 72 for counterpart EXP
%%	a=log(inImage0); %%%  see lines 72 for counterpart EXP
%%	if min_3(a) < 0 
%		b= a - min_3(a);
%%	else
%%		b= a + min_3(a);
%%	end
%	c=b ./ max_3(b);
%%	max_3(c)
%%	min_3(c)
%	inImage00=c;
%else 
	inImage00=inImage0;
%end

%figure;
%imshow(inImage00);
%inImage1=double(inImage0);
inImage1=inImage00;
R=inImage1(:,:,1); 
G=inImage1(:,:,2); 
B=inImage1(:,:,3);
inSize = size(inImage1);

% We put the pixels in the input image into the rows of a very large matrix
if length(inSize)==3
    inImage2 = reshape(inImage1, inSize(1)*inSize(2),inSize(3));
end

% We post-multiply by colorMatrix to convert the pixels to the output color space
%colormatrix=cmatrix(colorMatrix);
colormatrix=NDf;
outImage0 = inImage2 * colormatrix;

% Now we put the output image in the basic shape we use
if length(inSize)==3
    inImage3 = reshape(inImage2, inSize(1),inSize(2),inSize(3));
    outImage1 = reshape(outImage0, inSize(1),inSize(2),inSize(3));
end

%if HDR ==1
%%outImage1=exp(outImage1);
%end

oi_min = min(min(min(outImage1)));
if (oi_min < 0)
	outImage1 = outImage1 - oi_min;
end

oi_max = max(max(max(outImage1)));
if oi_max > 1
	outImage1 = outImage1 / oi_max;
end

outImage2 = outImage1;

%if HDR==0
%	imwrite(outImage2,['outImage_' colorMatrix '.tif'],'tiff');
%end

%if HDR==1
%	imwrite(outImage2,['outImage_' colorMatrix '.tif'],'tiff');
%	a=outImage2;
%	if min_3(a) < 0 
%		b= a - min_3(a);
%	else
%		b= a + min_3(a);
%	end
%	c=b ./ max_3(b);
%	outImage2=c;
%	radwrite(outImage2,[inImage '_out.hdr'],'rgbe');
%	max_3(outImage2b)
%	min_3(outImage2b)
%end

outImage=outImage2;
% The following commented out for use with 'filter_spec.m'.
%ppmwrite(outImage2, 'changecolorspace.ppm');
%figure;
%imshow(outImage);

%    colorMatrix = 'lms2opp'   %  -- cone coordinate to opponent (Poirson & Wandell 1993)
%    colorMatrix = 'opp2lms'   %  -- inverse of the above matrix
%    colorMatrix = 'xyz2opp'   %  -- xyz to opponent (CIE1931 2 degree XYZ)
%    colorMatrix = 'opp2xyz'   %  -- inverse of the above matrix
%    colorMatrix = 'lms2xyz'   %  -- Hunt-Pointer-Estevez transformation from cone to XYZ, normalized for D65 (lms=[100 100 100] for D65).
%    colorMatrix = 'xyz2lms'   %  -- inverse of lms2xyz.
%    colorMatrix = 'xyz2yiq'   %  -- convert from XYZ to YIQ
%    colorMatrix = 'yiq2xyz'   %  -- inverse of the abvoe matrix
%    colorMatrix = 'rgb2yuv'   %  -- convert from RGB to YUV (YCbCr) for JPEG compression
%    colorMatrix = 'yuv2rgb'   %  -- inverse of the above matrix
%    colorMatrix = 'xyz2srgb'   %  -- from XYZ to sRGB values
%    colorMatrix = 'srgb2xyz'   %  -- inverse of the above matrix (the above are not dependent on device calibration)
%    colorMatrix = 'rgb2lms'   %  -- monitor rgb to cone coordinate
%    colorMatrix = 'lms2rgb'   %  -- inverse of the above matrix
%    colorMatrix = 'rgb2xyz'   %  -- rgb to xyz 2 degree.
%    colorMatrix = 'xyz2rgb'   %  -- inverse of the above matrix
%
% changeColorSpace('unfiltered.tif', 'rgb2lms',0);
% changeColorSpace('unfiltered.tif', 'rgb2xyz',0);
% changeColorSpace('unfiltered.tif', 'rgb2yuv',0);
% 
% changeColorSpace('outImage_rgb2lms.tif', 'lms2rgb',0);
% changeColorSpace('outImage_rgb2xyz.tif', 'xyz2rgb',0);
% changeColorSpace('outImage_rgb2yuv.tif', 'yuv2rgb',0);
% 
%     changeColorSpace('zbelg-h.hdr', 'rgb2xyz', 1);
%     changeColorSpace('chart_unfiltered.tif', 'ND-filter', 0);
%     changeColorSpace('sky_unfiltered.tif', 'ND-filter', 0);
%     changeColorSpace('chart_filtered.tif', 'ND-filter', 0);
%     changeColorSpace('sky_filtered.tif', 'ND-filter', 0);

