function [A,wp,rgb1] = filter_spec(im_xyz,im_trgb)
% 	im_xyz and im_rgb are variables that contain loaded images.
%	xyz.tif and trgb.tif are images of 4x6 color matrices, filtered and unfiltered.
%	The image "_filtered.ppm" is an image of a TV screen with a Macbeth Color chart being displayed.
%	The rgb equivalents for the Macbeth chart are known so analyzing the difference between
%	given values and expected values is done with the mathematics. The matrix that results is incorporated
%	into the "cmatrix.m: file as "NDfilter2rgb" and "rgb2NDfilter" choice options.

% load images and extract xyz, trgb data from color squares.
% filtered.mat and _unfiltered.mat are the result

chart = reshape( 1:24, 6, 4 )';

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Reshape xyz,trgb and call 'macbethcolormatch'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xyz=im_xyz';% Use transpose, not reshape
trgb=im_trgb';% Use transpose, not reshape
[A, wp, rgb] = macbethcolormatch( xyz, trgb) ;
% A
% wp : white point
% rgb ; matrix
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make an image of 'rgb' and save it.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rgb1=rgb;
rgb2=ind2rgb(chart,rgb1);
rgb3=reshape(rgb2,4,6,3); % 'reshape' requires position before 'resize'
rgb4=imresize(rgb3,40);
if min_3(rgb4) <0
	rgb1=rgb4-min_3(rgb4);
end
if max_3(rgb4)>1
	rgb1=rgb4./max_3(rgb4);
end
% if max_3(rgb) > 1
% 	rgb4=rgb4./255;
% end
%figure;imshow(rgb4);
%imwrite(rgb4,'ufout.tif');
NDf=A;
rgby=changecolorspace('cgi-chart_unfiltered.tif','rgb2NDfilter',0,NDf);
 R=rgby(:,:,1);
 G=rgby(:,:,2); 
 B=rgby(:,:,3);
NAME=filename(1:(size(filename,2)-4))
ppmwrite ( R, G, B, [NAME '_ND.ppm'], 255, 'binary' )

