function [A, wp, rgb] = macbethcolormatch( xyz, trgb) 

if ( nargin == 0 | nargin > 2 ) 
  disp( 'Input error.' );
  break; % exit;
else
  if ( nargin == 1 ) 
	disp('ERROR - no target matrix specified.');
  end
end

% How does this differ from conversion by post-multiplication?
A = trgb * xyz' * inv( xyz * xyz' ); 
%	a * inv(a) * a = a
%	a * a' : is symmetric about the diagonal
%	A * a : converts A to colorspace a

%	xyz=rand(3)
% Substitue xyz for trgb to test :
%	A= xyz * xyz' * inv(xyz*xyz')
%       [xyz' * inv(xyz*xyz')] evaluates to the inverse of 'a' as is shown next.
%       a=xyz; b= xyz' * inv(xyz*xyz');
%	a * b
%	b * a
%%	b*a = a*b = I

if ( nargout > 1 )

% In 'changeColorMatrix.m', the image is post-multiplied by the color matrix.
% Here , the reverse appears to be true.
% A is a 3x3 matrix and xyz is a 24x3 matrix of Macbeth chart values
  mrgb = A * xyz; 
  
  wp = max( mrgb' );

  if ( nargout == 3 )
    r = mrgb(1,:)';
    g = mrgb(2,:)';
    b = mrgb(3,:)';


    r = r / wp(1);
    g = g / wp(2);
    b = b / wp(3);

    r = r .* (r >= 0);
    g = g .* (g >= 0);
    b = b .* (b >= 0);

    rgb = [ r g b ];
  end
end

