function char = pnmgetc(fid)
%PNMGETC  Get character from PBM/PGM/PPM file.
%
%   CHAR = PNMGETC(FID) gets the next character from the PBM/PGM/PPM
%   file with file identifier FID. Comments are skipped.

%   1997-09-02 14:47:19  Peter J. Acklam <jacklam@math.uio.no>

[ char, count ] = fscanf( fid, '%c', 1 );
if ( count == 0 )
   fclose( fid );
   error( 'File ended while reading.' );
end

if ( char == '#' )
   nl = sprintf('\n');
   cr = sprintf('\r');
   while ( ( char ~= nl ) & ( char ~= cr ) )
      [ char, count ] = fscanf( fid, '%c', 1 );
      if ( count == 0 )
         fclose( fid );
         error( 'File ended while reading.' );
      end
   end
end
