function int = pnmgeti(fid)
%PNMGETI  Get integer PBM/PGM/PPM file.
%
%   INT = PNMGETI(FID) gets the next integer from the PBM/PGM/PPM file
%   with file identifier FID. Comments are skipped.

%   1997-09-02 14:47:22  Peter J. Acklam <jacklam@math.uio.no>

spc = ' ';
ht  = sprintf( '\t' );
nl  = sprintf( '\n' );
cr  = sprintf( '\r' );

char = spc;     % Initialize to something test will make test true.
while ( char == spc ) | ( char == ht ) | ( char == nl ) | ( char == cr )
   char = pnmgetc( fid );
end

if ( char < '0' ) | ( char > '9' )
   fclose( fid );
   error( 'Junk in file where an integer should be.' );
end

int = 0;
while ( char >= '0' ) & ( char <= '9' )
   int = int * 10 + char - '0';
   char = pnmgetc( fid );
end
